#pragma once

#include <l3tde/map/header.h>
#include <l3tde/map/node.h>
#include <l3tde/map/interface.h>
#include <l3tde/map/warp.h>

// Types in interface.h to avoid recursive inclusion in warp.h
struct L3TDEMap {
    // Must be rectangular.
    size_t nodes_x_len;
    size_t nodes_y_len;
    size_t warps_len;

    L3TDEMapHeaderPtr header;
    L3TDEMapNodePtr **nodes;
    L3TDEMapWarpPtr *warps;
};

L3TDEMapPtr
l3tde_map_create (L3TDEMapHeaderPtr header,
    L3TDEMapNodePtr **nodes, size_t nodes_x_len, size_t nodes_y_len,
    L3TDEMapWarpPtr *warps, size_t warps_len);

void
l3tde_map_destroy (L3TDEMap *self);
