#include <stddef.h>
#include <stdlib.h>

#include <l3tde/map/terrain.h>
#include <l3tde/util/string.h>

L3TDEMapTerrainPtr
l3tde_map_terrain_create (const char *name, size_t name_len,
        char symbol, short foreground, short background) {
    L3TDEMapTerrainPtr self = malloc (sizeof *self);

    self->name = copy_string (name, name_len);
    self->name_len = name_len;
    self->symbol = symbol;
    self->foreground = foreground;
    self->background = background;

    return self;
}

void
l3tde_map_terrain_destroy (L3TDEMapTerrainPtr self) {
    if (self->name) {
        free (self->name);
        self->name = NULL;
    }

    free (self);
}
